//warning: 3 very different people worked on this and they were all me
//code quality? not in my kitchen




const deg_to_rad = deg => (deg * Math.PI) / 180 //math????? in MY video game?
const rand_int = (min, max) => Math.floor(Math.random() * (max - min)) + min //min inclusive, max exclusive
const clamp_num = (some_num, min, max) => Math.max(min, Math.min(max, some_num)) //

PIXI.Rectangle.prototype.intersects = function(other) {
    const x0 = this.x < other.x ? other.x : this.x;
    const x1 = this.right > other.right ? other.right : this.right;
    if (x1 <= x0)
    {
        return false;
    }
    const y0 = this.y < other.y ? other.y : this.y;
    const y1 = this.bottom > other.bottom ? other.bottom : this.bottom;
    return y1 > y0;
} //polyfill from @pixi/math-extras

let mariBitmaps = {
  dw: ImageManager.loadBitmap('img/pictures/', 'mb_mari_dw', 0, true),
  fa: ImageManager.loadBitmap('img/pictures/', 'mb_mari_fa', 0, true),
  gh: ImageManager.loadBitmap('img/pictures/', 'mb_mari_gh', 0, true)
}
let coolPivot = new PIXI.Point(30,20)

class mariBird extends Sprite {
  constructor() {
    super(mariBitmaps['dw'])
    this.scale = new Point(0.5,0.5)

    this._upperSprite = new Sprite(mariBitmaps['gh'])
    this._upperSprite.alpha = 0
    this.addChild(this._upperSprite)

    this._counterSprite = new Sprite(mariBitmaps['dw'])
    this._counterSprite.visible = false
    this._counterSprite.scale = new Point(0.5,0.5)

    this._counterSprite._upperSprite = new Sprite(mariBitmaps['gh'])
    this._counterSprite._upperSprite.alpha = 0
    this._counterSprite.addChild(this._counterSprite._upperSprite)

    this.dead = false
    this.gravity = 0.09
    this.terminalVelocity = 5
    this.terminalUpVelocity = 3.5
    this.vX = 0
    this.vY = 0
    this.verticalWrap = false

    this._jumpDebounce = 4
    this._jumpDebounceMax = 4

  }
  changePos(nX, nY) {
    this.x = nX === undefined ? this.x : nX
    this.y = nY === undefined ? this.y : nY
    if (this.verticalWrap) {
      this.y = this.y % Graphics.height
      if (this.y < 0) {
        this.y += Graphics.height
      }
    }
    if (this.y > Graphics.height/2) {
      this._counterSprite.y = this.y - Graphics.height
    } else {
      this._counterSprite.y = this.y + Graphics.height
    }
    this._counterSprite.x = this.x
  }
  changeRot(newRot) {
    if (this.pivot.y === 0) {
      this.pivot = coolPivot
    }
    if (this._counterSprite.pivot.y === 0) {
      this._counterSprite.pivot = coolPivot
    }
    this.rotation = deg_to_rad(newRot)
    this._counterSprite.rotation = deg_to_rad(newRot)
  }
  jump() {
    if (this._jumpDebounce === 0) {
      if (!this.dead) {
        if (this.y > 0) {
          //BA_download_attack at 150 for point gain
          //BA_Drink at 150 for jump?
          //BA_rubberband for OJ?
          //GEN_boing
          //GEN_clothy
          //GEN_Jump
          //mini_sh_ek 140
          //SE_dig death?
          AudioManager.playSe({name: "BA_Drink", pan: 0, pitch: 400, volume: 90});
          this.vY = clamp_num(this.vY - 3, -3, -this.terminalUpVelocity)
          this._jumpDebounce = this._jumpDebounceMax
        }
      }
    }
  }
  changeBitmap(newBitmap) {
    this.bitmap = newBitmap
    this._counterSprite.bitmap = newBitmap
  }
  changeUpper(newBitmap) {
    this._upperSprite.bitmap = newBitmap
    this._counterSprite._upperSprite.bitmap = newBitmap
  }
}

class DGT_birdGame_scene extends Scene_Base {
  constructor() {
    super()
    //this.initialize()
  }
  initialize() {
    super.initialize()

    this._groundOffset = 30
    this._pipeVariation = 200
    this._pipeGap = 48
    this._pipeMaxCooldown = 180


    let tData = $transitionData
    this.createIntroData()
    AudioManager.loadBgm("boss_fear_heights")

    this._dlf = false
    this.points = 0
    this.num_pipes = 0
    this._tubeSprites = []
    this._pipeCooldown = NaN
    this._difficultyFrameCount = 0
    this._lastPipeLoc = 240
    this._world = 0
    this._introPlaying = true
    this._inputDisabled = true
    this._inTransition = true
    this._transitionData = []
    for (let i = 0; i < 184; i++) {
      this._transitionData.push([-0.15, -1/180])
    }

    this._pipeContainer = new PIXI.Container()
    this._pipeBitmaps = [
      ImageManager.loadBitmap('img/pictures/', 'cringe_vines', 0, true),
      ImageManager.loadBitmap('img/pictures/', 'cringe_hands', 0, true)
    ]

    this._stairContainer = new PIXI.Container()
    this._stairContainer.alpha = 0
    this._stairIncrease = 0
    this._stairContainer.visible = false
    let stairStripBitmaps = []
    for (let i = 0; i < 32; i++) {
      stairStripBitmaps.push(ImageManager.loadBitmap('img/pictures/', `bs_stair_strip_${i}`, 0, true))
    }
    let centerYPoint = new PIXI.Point(0,0.5)
    this._stairContainer.anchor = centerYPoint
    for (let i = 0; i <= Math.ceil(Graphics.width/32); i++) {
      for (let j = 0; j < 32; j++) {
        let newStairStrip = new Sprite(stairStripBitmaps[j])
        //newStairStrip.anchor = centerYPoint
        let xPos = (i*32) + (j)
        let stairYScale = ((xPos/8)/8)
        newStairStrip.x = Graphics.width - xPos
        newStairStrip.scale = new PIXI.Point(
          0.5,
          0.5 + stairYScale
        )
        newStairStrip.y = (960-((1+stairYScale)*960))/2
        this._stairContainer.addChild(newStairStrip)
      }
    }

    this._groundSprite = new TilingSprite()
    this._groundSprite.move(0, Graphics.height - this._groundOffset, Graphics.width, this._groundOffset)
    this._groundSprite.bitmap = ImageManager.loadBitmap('img/pictures/', 'ground', 0, true)
    this._groundSprite2 = new TilingSprite()
    this._groundSprite2.move(0, Graphics.height - this._groundOffset, Graphics.width, this._groundOffset)
    this._groundSprite2.bitmap = ImageManager.loadBitmap('img/pictures/', 'fa_ground', 0, true)

    this._backgroundSprite = new TilingSprite()
    this._backgroundSprite.move(0, 0, Graphics.width, Graphics.height)
    this._backgroundSprite.bitmap = ImageManager.loadBitmap('img/parallaxes/', 'Space_parallax', 0, true)
    this._backgroundSprite2 = new TilingSprite()
    this._backgroundSprite2.move(0, 0, Graphics.width, Graphics.height)
    this._backgroundSprite2.bitmap = ImageManager.loadBitmap('img/parallaxes/', '!polaroidBG_FA_day', 0, true)

    this._pointCounter = new Window_Base(212,445,70,30)
    this._pointCounter.standardPadding = () => 0
    this._pointCounter.padding = 0
    this._pointCounter.createContents()
    this._pointCounter.contents.fontSize = 20
    this._pointCounter.drawText("0", 8, -6, 54, "right")

    this._stairVig = new Sprite(ImageManager.loadBitmap('img/pictures/', 'stair_vig', 0, true))
    this._stairVig.alpha = 0
    this._stairVig.visible = false

    this._groundSprite.origin.x = tData[0]
    this._backgroundSprite.origin.x = tData[1]
    this._backgroundSprite.origin.y = tData[2]
    this._groundSprite2.origin.x = tData[0]
    this._backgroundSprite2.origin.x = tData[1]
    this._backgroundSprite2.origin.y = tData[2]
    this._groundSpeed = tData[3]
    this._bgSpeedX = tData[4]
    this._bgSpeedY = tData[5]

    this._playerCharacter = new mariBird()
    this._playerCharacter.x = -50

    this.addChild(this._backgroundSprite)
    this.addChild(this._backgroundSprite2)
    this.addChild(this._groundSprite)
    this.addChild(this._groundSprite2)
    this.addChild(this._stairContainer)
    this.addChild(this._pipeContainer)
    this.addChild(this._playerCharacter)
    this.addChild(this._playerCharacter._counterSprite)
    this.addChild(this._pointCounter)
    this.addChild(this._stairVig)
  }
  createIntroData() {
    this._introData = []
    for (let i = 0; i < 300; i++) {
      this._introData.push(i < 120 ? i/80 : 0)
    }
  }
  updateIntro() {
    let pC = this._playerCharacter
    if (this._introData.length !== 0) {
      pC.changePos(pC.x + this._introData.pop())
    } else {
      //this._introPlaying = false //intro stops after first input
      this._inputDisabled = false
    }
    if (pC.y >= 270) {
      pC.jump()
    }
  }
  updateStairs() {
    for (const stairSprite of this._stairContainer.children) {
      let sSX = (stairSprite.x + 15.5 + this._stairIncrease) % Graphics.width
      stairSprite.x = sSX
      let sYScale = (((Graphics.width - sSX)/8)/8)*0.8
      stairSprite.y = (960-((1.2+sYScale)*960))/2
      stairSprite.scale.y = 0.7 + sYScale
    }
  }
  updateTransition() {
    let currentChange = this._transitionData.length === 0 ? [0,0] : this._transitionData.pop()
    this._groundSpeed += currentChange[0]
    this._bgSpeedX += currentChange[0]
    this._backgroundSprite2.alpha += currentChange[1]
    this._groundSprite2.alpha += currentChange[1]
    if (this._transitionData.length === 0 && this._inTransition) {
      this._inTransition = false
      this._backgroundSprite2.alpha = 0
      this._backgroundSprite2.bitmap = this._backgroundSprite.bitmap
      this._groundSprite2.alpha = 0
      this._groundSprite2.bitmap = this._groundSprite.bitmap
    }
  }
  moveSceneObjects() {
    this._groundSprite.origin.x += this._groundSpeed
    this._backgroundSprite.origin.x += this._bgSpeedX
    this._backgroundSprite.origin.y += this._bgSpeedY
    this._groundSprite2.origin.x += this._groundSpeed
    this._backgroundSprite2.origin.x += this._bgSpeedX
    this._backgroundSprite2.origin.y += this._bgSpeedY
    this._pipeContainer.children.forEach((pipe) => {
      pipe.x -= this._groundSpeed
      if (pipe.y > this._playerCharacter.y) {
        if (pipe.x+20 < this._playerCharacter.x) {
          if (!pipe.collected) {
            pipe.collected = true
            console.log("GET")
            this.increasePoints()
          }
        }
      }
      if (pipe.x <= -pipe.width) {
        pipe.destroy()
      }
    })
  }
  increasePoints() {
    if (!this._playerCharacter.dead) {
      this.points++
      console.log(this.points)
      this._pointCounter.contents.clear()
      this._pointCounter.drawText(this.points, 8, -6, 54, "right")
      this._groundSpeed +=0.05
      AudioManager.playSe({name: "BA_download_attack", pan: 0, pitch: 150, volume: 90});
    }
    if (this.points == 35) {
      this._unStairTransition = true
    }
  }
  processInput() {
    if (!this._inputDisabled) {
      if (Input.isTriggered('ok')) {
        if (!this._inMenu) {
          if (this._introPlaying) {
            this._introPlaying = false
            this._pipeCooldown = this._pipeMaxCooldown/4
          }
          this._playerCharacter.jump()
        } else {
          // m
        }
      }
      if (Input.isTriggered('oKey')) {
        this._playerCharacter._counterSprite.visible = true
        this._playerCharacter.verticalWrap = true
      }
    }
  }
  updateBPos() {
    let pC = this._playerCharacter
    pC.vY = Math.min(pC.vY + pC.gravity, pC.terminalVelocity)
    if ((pC.y >= 446) && !pC.verticalWrap) {
      pC.dead = true
      pC.vY = 0
    }
    pC.changePos(pC.x + pC.vX, pC.y + pC.vY)
    pC.changeRot( clamp_num(pC.vY*12, -40, 55) )
    if (pC._jumpDebounce > 0) {pC._jumpDebounce--}
    if (pC.dead) {
      this._groundSpeed = 0
      if (pC.verticalWrap) {
        pC.vY += pC.y >= Graphics.height/2 ? -1 : 1
        pC.vX += 0.25
      }
      SceneManager._scene._pipeContainer.children.forEach((pipe) => {
        pipe.alpha -= 0.03
      });

    }
  }
  createPipeSet(offset) {
    let pipe1 = new Sprite(this._pipeBitmaps[this._world])
    let pipe2 = new Sprite(this._pipeBitmaps[this._world])
    pipe1.x = Graphics.width + pipe1.width + 5
    pipe2.x = Graphics.width + pipe2.width + 5
    pipe1.y = offset - (pipe1.height + this._pipeGap)
    pipe2.y = offset + this._pipeGap
    this._pipeContainer.addChild(pipe1)
    this._pipeContainer.addChild(pipe2)
  }
  pipeGenerator() {
    this._pipeCooldown--
    if (this._pipeCooldown <= 0) {
      if (this._world == 1) {
        this._pipeMaxCooldown = Math.max(20, this._pipeMaxCooldown-10)
      }
      this._pipeCooldown = this._pipeMaxCooldown
      let new_loc = rand_int(-this._pipeMaxCooldown * 0.65, this._pipeMaxCooldown * 0.65) + this._lastPipeLoc
      new_loc = clamp_num(new_loc, 60, Graphics.height - 80)
      this.createPipeSet(new_loc)
      this._lastPipeLoc = new_loc
      this.num_pipes++
      if (this.num_pipes == 10) {
        AudioManager.fadeBgmTo(0, 120)
        this._pipeCooldown = 500
        this._world = 1
        this._stairContainer.visible = true
        this._stairVig.visible = true
        this._doStairTransition = true
        this._pipeGap += 20
      } else if (this.num_pipes == 35) {
        this._groundSprite.visible = false
        this._groundSprite2.visible = false
        this._backgroundSprite.visible = false
        this._backgroundSprite2.visible = false
        this._pipeCooldown = NaN

      }
    }
  }
  processCollisions() {
    let kill = false
    this._playerCharacter.calculateBounds()
    let bB = this._playerCharacter._bounds
    let birdRect = new PIXI.Rectangle(bB.minX+8, bB.minY+8, (bB.maxX-bB.minX)-16, (bB.maxY-bB.minY)-16)
    for (i=0; i < this._pipeContainer.children.length; i++) {
      let pipe = this._pipeContainer.children[i]
      let pipeRect = new PIXI.Rectangle(pipe.x,pipe.y,pipe.width,pipe.height)
      if (pipeRect.intersects(birdRect)) {
        kill = true
      }
    }
    if (kill) {
      this._playerCharacter.dead = true
    }
  }
  updateDifficulty() {
    let pC = this._playerCharacter
    if (!pC.dead) {
      this._difficultyFrameCount++
      this._pipeGap -= 0.005
    } else {
      if (!this._dlf) {
        this._deathframes = 120
        this._dlf = true
        AudioManager.playSe({name: "BA_do_nothing_distracted", pan: 0, pitch: 50, volume: 90});
        AudioManager.fadeBgmTo(0, 60)
      } else {
        this._deathframes--
        if (this._deathframes <= 0) {
          SceneManager.goto(Scene_OmoriTitleScreen)
        }
      }
    }
  }
  updateStairTransition() {
    if (this._stf === undefined) {
      this._stf = 501
    }
    this._stf--
    let pC = this._playerCharacter
    if (this._stf !== 0) {
      pC._upperSprite.alpha += 1/501
      pC._counterSprite._upperSprite.alpha += 1/501
      this._stairContainer.alpha += 1/501
      this._stairVig.alpha += 0.6/501
    } else {
      AudioManager.playBgm({name: "boss_fear_heights", pan: 0, pitch: 100, volume: 0})
      AudioManager.fadeBgmTo(90, 500)
      pC.verticalWrap = true
      this._doStairTransition = false
    }
  }
  updateUnTransition() {
    if (this._utf === undefined) {
      this._utf = 80
      this._uts = 0
    }
    this._utf--
    if (this._utf <= 0) {
      if (this._uts == 0) {
        this._uts++
        this._utf = 180
      } else if (this._uts == 1) {
        this._uts++
        this._utf = 60

        if ($modLoader) {
          try {
            $modLoader.native_fs.renameSync("www/mods/mari_bird.zip", "www/mods/_mari_bird.zip")
          } catch(e) {
            try {
              $modLoader.native_fs.renameSync("www/mods/mari_bird", "www/mods/_mari_bird")
            } catch(e) {
              //do NOTHING
            }
          }
        }
      } else if (this._uts == 2) {
        this._uts++
        this._utf = 40
        AudioManager.playSe({name: "GEN_wham", pan: 0, pitch: 20, volume: 200});


      } else if (this._uts == 3) {
        SceneManager.terminate()
      }
    }
    if (this._uts == 1) {
      SceneManager._scene.alpha -= 1/120
    }
  }
  update() {
    this.processInput()
    this.pipeGenerator()
    this.updateTransition()
    this.moveSceneObjects()
    this.updateBPos()
    this.processCollisions()
    this.updateDifficulty()
    if (this._doStairTransition) {
      this.updateStairTransition()
    }
    if (this._unStairTransition) {
      this.updateUnTransition()
    }
    if (this._stairContainer.visible === true) {
      this.updateStairs()
    }
    if (this._introPlaying) {
      this.updateIntro()
    }

  }
}
